<?php

/**
 * oficio_deudor actions.
 *
 * @package    cobro_coactivo
 * @subpackage oficio_deudor
 * @author     MEPL
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class oficio_deudorActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_OFICIO_DEUDOR',
        'CBR_REMISION_TITULO',
        'CBR_REMISION_TIT_AGRUP_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_OFICIO_DEUDOR'
        ),
        'CBR_REMISION_TIT_AGRUP_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_OFICIO_DEUDOR' =>
        array(
            'id_oficio_deudor' => 'id_oficio_deudor',
            'id_remision_titulo' => 'id_remision_titulo',
            'no_oficio' => 'no_oficio',
            'fecha_envio' => 'fecha_envio',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'fecha_aprueba' => 'fecha_aprueba',
            'usuario_aprueba' => 'usuario_aprueba'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado'
        ),
        'CBR_REMISION_TIT_AGRUP_V' =>
        array(
            'cod_titulo_det_agrup' => 'cod_titulo_det_agrup',
            'observaciones_det_agrup' => 'observaciones_det_agrup',
            'mineral_det_agrup' => 'mineral_det_agrup'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_OFICIO_DEUDOR' =>
        array(
            'id_oficio_deudor,a' => array('!=' => array(-1)),
            'id_oficio_deudor,b' => array('=' => array('id_oficio_deudor')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_oficio_deudor'; //identificador de la tabla
    protected $id_names = array('id_oficio_deudor'); //llave primaria
    protected $field_names = array('id_remision_titulo', 'no_oficio', 'fecha_envio',
        'observaciones', 'adjunto', 'usuario_log', 'fecha_aprueba', 'usuario_aprueba'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_OFICIO_DEUDOR'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_oficio_deudor'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        $id_oficio_deudor = $list_data_post[0]['id_oficio_deudor'];
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['id_username'];
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "Aprobar") {
                $this->envioNotificacion($request, $id_oficio_deudor,true);
            }
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "Rechazar") {
                $this->envioNotificacion($request, $id_oficio_deudor,false);
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "Aprobar") {
                $this->envioNotificacion($request, $id_oficio_deudor,true);
            }
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "Rechazar") {
                $this->envioNotificacion($request, $id_oficio_deudor,false);
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "Aprobar") {
                $request['usuario_aprueba'] = $request['id_username'];
                $request['fecha_aprueba'] = CN_TABLE::fechaSistema();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "Aprobar") {
                $request['usuario_aprueba'] = $request['id_username'];
                $request['fecha_aprueba'] = CN_TABLE::fechaSistema();
            }
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
    /**
     * Correo de notificacion de aprobacion - 20200304
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacion($request, $id_filtro,$aprobado) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }
        if($aprobado) {
            $mensaje = "'Se realiza la aprobación del oficio de salida de deudor No.'|| avoc.no_oficio || ' de los titulos mineros ' || det.cod_titulo_det_agrup  || ', verificar recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision || ', se envia correo al abogado( '|| ter.num_doc || '-' || ter.razon_soc ||' ).'";
            $asunto = "'Aprobacion Oficio salida deudor - Recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision || ' de los Titulos: ' || det.cod_titulo_det_agrup";
        } else {
            $mensaje = "'Se realiza el rechazo del oficio de salida de deudor No.'|| avoc.no_oficio || ' de los titulos mineros ' || det.cod_titulo_det_agrup  || ', verificar recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision || ', se envia correo al abogado( '|| ter.num_doc || '-' || ter.razon_soc ||' ).'";
            $asunto = "'Rechazo Oficio salida deudor - Recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision || ' de los Titulos: ' || det.cod_titulo_det_agrup";
        }

        /**
         * Envio de correo de error - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CBR_REGISTRO_ETAPA');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
avoc.id_oficio_deudor as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
                
avoc.id_oficio_deudor,
avoc.no_oficio,
remi.numero_remision,
remi.anho_remision as id_anhos,
det.cod_titulo_det_agrup as cod_titulo,
ter.id_tipo_doc,
ter.num_doc,
ter.razon_soc,
abo.email as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
$mensaje as mensaje,
$asunto as subject,                        
                
--datos de envio
ter.num_doc as num_doc_env,
ter.id_tipo_doc as id_tipo_doc_env,
ter.razon_soc as razon_social_env,
abo.email as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.nombre as razon_social_usu,
usu.email as correo_usu

from cbr_oficio_deudor avoc

left join cbr_reparto repa
on repa.id_remision_titulo = avoc.id_remision_titulo

left join cbr_remision_titulo remi
on avoc.id_remision_titulo = remi.id_remision_titulo

left join CBR_REMISION_TIT_AGRUP_V det
on det.id_remision_titulo = remi.id_remision_titulo

left join cbr_abogado abo
on abo.id_abogado = repa.id_abogado

left join interceros_v ter
on ter.id_mae_ter = abo.id_mae_ter

left join usuario usu
on usu.username = '$username'

where
avoc.id_oficio_deudor = $id_filtro
and avoc.no_oficio is not null
and repa.estado = 1    
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            /**
             * Datos de envio
             *
              $params = array(
              'user_from' => 'webservice',
              'recipients' => $recipients,
              'asunto' => 'Error webservie_sigm_consulta',
              'body' => $body
              );
             * 
             */
            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
            
            /*
             * Enviamos copias del correo a los coordinadores - 20210312
             */
            //consulta los coordinadores 
            $sql = <<<EOD
select 
    tab0.email,tab1.id_tipo_doc,
        tab1.num_doc,tab1.razon_soc
from CBR_ABOGADO tab0
left join interceros tab1 
    on tab1.id_mae_ter = tab0.id_mae_ter
where es_coor = 1     
EOD;
            $coordinadores = CN_TABLE::executeSQL($sql);
            //$i = 1;
            foreach ($coordinadores as $coordinador) {

                //ENVIADO
                $params['num_doc_env'] = $coordinador['num_doc'];
                $params['id_tipo_doc_env'] = $coordinador['id_tipo_doc'];
                $params['razon_social_env'] = $coordinador['razon_soc'];
                $params['correo_env'] = $coordinador['email'];

                //USUARIO
                $params['num_doc_usu'] = '';
                $params['id_tipo_doc_usu'] = '';
                $params['razon_social_usu'] = '';
                $params['correo_usu'] = '';

                if ($service_url != null) {
                    CN_TABLE::curlPostAsync($url, $params);
                }
            }
        }

        $logger->info("Envio de correo fin");
    }

}
